/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: XMLNamespace.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_XMLNamespace_H
#define OpenSOAP_XMLNamespace_H

#include <OpenSOAP/String.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct tagOpenSOAPXMLNamespace OpenSOAPXMLNamespace;
    typedef OpenSOAPXMLNamespace *OpenSOAPXMLNamespacePtr;

    int
    OPENSOAP_API
    OpenSOAPXMLNamespaceCreateMB(const char * /* [in] */ ns_uri,
                                 const char * /* [in] */ ns_prefix,
                                 OpenSOAPXMLNamespacePtr * /* [out] */ ns);

    int
    OPENSOAP_API
    OpenSOAPXMLNamespaceCreateWC(const wchar_t * /* [in] */ ns_uri,
                                 const wchar_t * /* [in] */ ns_prefix,
                                 OpenSOAPXMLNamespacePtr * /* [out] */ ns);
    int
    OPENSOAP_API
    OpenSOAPXMLNamespaceRelease(OpenSOAPXMLNamespacePtr /* [in, out] */ ns);

    int
    OPENSOAP_API
    OpenSOAPXMLNamespaceGetURI(OpenSOAPXMLNamespacePtr /* [in] */ ns,
                               OpenSOAPStringPtr * /* [out] */ ns_uri);

    int
    OPENSOAP_API
    OpenSOAPXMLNamespaceGetPrefix(OpenSOAPXMLNamespacePtr /* [in] */ ns,
                                  OpenSOAPStringPtr * /* [out] */ ns_prefix);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_XMLNamespace_H */
