/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ChannelDescriptor.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include "ServerCommon.h"
#include "ChannelDescriptor.h"

using namespace OpenSOAP;

//==== ChannelDescriptor ====
//t@CfBXNv^NX


ChannelDescriptor::ChannelDescriptor()
  : readFd_(-1)
  , writeFd_(-1)
{
#ifdef DEBUG
  cerr << "ChannelDescriptor::ChannelDescriptor()" << endl;
#endif
}

ChannelDescriptor::ChannelDescriptor(const ChannelDescriptor&
						 aDesc)
  : id_(aDesc.id_)
  , readFd_(aDesc.readFd_)
  , writeFd_(aDesc.writeFd_)
{
#ifdef DEBUG
  cerr << "ChannelDescriptor::ChannelDescriptor(copy)" << endl;
#endif
}

ChannelDescriptor::ChannelDescriptor(const std::string& id)
  : id_(id)
  , readFd_(-1)
  , writeFd_(-1)
{
#ifdef DEBUG
  cerr << "ChannelDescriptor::ChannelDescriptor(" << id << ")" << endl;
#endif
}


ChannelDescriptor::~ChannelDescriptor()
{
#ifdef DEBUG
  cerr << "ChannelDescriptor::~ChannelDescriptor()" << endl;
#endif
}


void ChannelDescriptor::setId(const std::string& id)
{
  id_ = id;
}

void ChannelDescriptor::setReadFd(const int fd)
{
  readFd_ = fd;
}

void ChannelDescriptor::setWriteFd(const int fd)
{
  writeFd_ = fd;
}

int& ChannelDescriptor::getReadFd()
{
  return readFd_;
}

int& ChannelDescriptor::getWriteFd()
{
  return writeFd_;
}


int ChannelDescriptor::read(std::string& data)
{
  //OpenSOAP::read call.
  return OpenSOAP::read(readFd_, data);
}

int ChannelDescriptor::write(const std::string& data)
{
  //OpenSOAP::write call.
  return OpenSOAP::write(writeFd_, data);
}

// End of ChannelDescriptor.cpp
