/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: FileIDFunc.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <vector>
#include <string>

/* IdMgr library */
#include "ServerCommon.h"
#include "DataRetainer.h"

std::string dir = "/var/tmp/OpenSOAP/Data/SOAPMessage";


/* SOAP bZ[WɑΉt@C ID 擾 */
std::string
convertToFileID(std::string message)
{
  cerr << "message = " << message << endl;
  
  std::string fileID;
  
  //DataRetainer CX^X
  OpenSOAP::DataRetainer* writer = new OpenSOAP::DataRetainer(dir);
  
  
  //DataContainer CX^X
  OpenSOAP::DataContainer dataCont;
  
  //f[^()Zbg
  dataCont.setData(message);
  
  //f[^putɐIdU
  int result = writer->put(dataCont);
  if (0 > result) {
    //error proc.
    // ...
    cerr << "put failed" << endl;
    return NULL;
  }
  
  cerr << "create DataFile writer finish" << endl;
  
  fileID = dataCont.getId().toString();
  
  cerr << "write id=[" << fileID << "]" << endl;
  
  delete writer;
  
  return fileID;
}

/* t@C ID ɑΉ SOAP bZ[W擾 */
std::string
revertFromFileID(std::string fileID) {
  
  //DataRetainer CX^X
  OpenSOAP::DataRetainer* reader = new OpenSOAP::DataRetainer(dir);
  
  //DataContainer CX^X
  OpenSOAP::DataContainer readDataCont;
  
  //MIdZbgAΉf[^ǂݍ
  readDataCont.setId(fileID);
  
  //f[^getɐƃf[^ǂݍ܂
  int result = reader->get(readDataCont);
  if (0 > result) {
    //error proc.
    // ...
    cerr << "get failed" << endl;
    return NULL;
  }
  
  //ǂݍ񂾃f[^(SOAPbZ[W)擾
  std::string message = readDataCont.getData();
  
  cerr << "create DataFile reader finish" << endl;
  cerr << "read=[" << message << "]" << endl;
  
  delete reader;
  
  return message;
}
