/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ServerCommon.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <cstdio>
#include <unistd.h>

#include "ServerCommon.h"

using namespace OpenSOAP;
/*
static const std::string TAG_ERR = "*** E ***:";
static const std::string TAG_WRN = "*** W ***:";
static const std::string TAG_INF = "*** I ***:";

static const std::string MSGDRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/MsgDrv";
static const std::string SRVDRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/SrvDrv";
static const std::string OpenSOAP::IDMGR_SOCKET_ADDR 
= "/var/tmp/OpenSOAP/SOCKET/IdManager";
*/

//======== common function ==============
int OpenSOAP::read(int fd, std::string& data)
{
  char readBuf[BUFSIZ];
  memset(readBuf, 0x00, sizeof(readBuf));
  ssize_t readLen = 0;
  data = "";

#if 0
  while (1) {
    readLen = std::read(fd, readBuf, sizeof(readBuf)-1);

    if (0 == readLen) {
#ifdef DEBUG
      cerr << "OpenSOAP::read 0 byte done." << endl;
#endif
      
      break;

    } 
    else if (0 > readLen) {
      cerr << TAG_ERR << "OpenSOAP::read failed" << endl;
      return -1;
    }

    readBuf[readLen] = 0x00;
    data += readBuf;

#ifdef DEBUG
    cerr << "OpenSOAP::read: [" << readBuf 
	 << "] len=(" << readLen << ")" << endl;
#endif

  }
#else // if 0
  readLen = std::read(fd, readBuf, sizeof(readBuf)-1);

  if (0 == readLen) {
#ifdef DEBUG
    cerr << "OpenSOAP::read 0 byte done." << endl;
#endif
      
  } 
  else if (0 > readLen) {
    cerr << TAG_ERR << "OpenSOAP::read failed" << endl;
    return -1;
  }

  readBuf[readLen] = 0x00;
  data += readBuf;

#ifdef DEBUG
  cerr << "OpenSOAP::read: [" << readBuf 
       << "] len=(" << readLen << ")" << endl;
#endif

#endif

  //return 0;
  return data.length();
}

int OpenSOAP::write(int fd, const std::string& data)
{
  char writeBuf[BUFSIZ];
  memset(writeBuf, 0x00, sizeof(writeBuf));
  ssize_t writeLen = 0;

  //std::string::size_type remainLen = data.length();
  int remainLen = data.length();

  while (remainLen > 0) {
    writeLen = std::write(fd, 
			  data.c_str()+(data.length() - remainLen), 
			  remainLen);
    
    if (0 > writeLen) {
      cerr << TAG_ERR << "OpenSOAP::write failed" << endl;
      return -1;
    } 
    else if (writeLen > remainLen) {
      cerr << "*** W ***:" << "OpenSOAP::write: invalid write length." << endl;
    }
    
    remainLen -= writeLen;
  }

  return data.length() - remainLen;
}



// End of ServerCommon.cpp
