/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Spool.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef SPOOL_H_
#define SPOOL_H_

#include <fstream>
#include <map>
#include <pthread.h>
#include <string>

namespace OpenSOAP {
  class ChannelDescriptor;
  
  class Spool {
  private:
    pthread_t pop_thread;
    pthread_mutex_t spool_mutex;
    //pthread_cond_t spool_cond;   
    
    char tableFile[100];
    std::ifstream min;
    std::ofstream mout;
    
    ChannelDescriptor chnlDesc_;  
    
    const std::string noEntryMsg;
  public:
    Spool(char filePass[100]);
    
    ~Spool(); 
    void setChnlDesc(const ChannelDescriptor& pushChnlDesc);
    bool execPushOpr();
    bool execPopOpr();
    
  private:
    int fileOut();
    int push(string msgID, string fileID);
    std::string pop(std::string msgID);
    
  private:
    struct MapRecord{
      //string msgID;
      std::string fileID;
    };
    
    multimap<string, MapRecord> spoolMap;
  };
}

#endif  SPOOL_H_
