/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: TTL.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <unistd.h>
#include <fstream.h>
#include <map>
#include <pthread.h>
#include <string>
#include <ctime>

namespace OpenSOAP {
  class ChannelDescriptor;
  
  class TTL {
  private:
    pthread_t watcher_thread;
    pthread_mutex_t ttl_mutex;
    //pthread_cond_t ttl_cond;
    
    char tableFile[100];
    ifstream min;
    ofstream mout;
    
    ChannelDescriptor chnlDesc_;  
    
  public:
    int watchInterval;
    int ttlMaxValue;
    
  public:
    TTL(char filePass[100]);
    ~TTL();
    void setChnlDesc(const ChannelDescriptor& chnlDesc);
    
    bool execPushOpr();
    bool execRefOpr();
    

  private:
    int fileOut();
    static void* watcher(void *arg);
    int eraseSignalToFIFO(std::string msgID, std::string fileID);
    
    int push(std::string msgID, std::string fileID, time_t startTime, 
	     int ttl, std::string backwardPath);
    std::string refBackwardPath(std::string msgID);
  private:
    struct mapRecord{
      std::string msgID;
      std::string fileID;
      time_t startTime;
      int ttl;
      std::string backwardPath;
    };
    
    multimap<time_t, mapRecord> ttlMap;
  };
  
}
