/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: XmlQuery.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef _XMLQuery_H_
#define _XMLQuery_H_

#include <string>
#include <vector>
#include <libxml/tree.h>
//#include <parser.h>

namespace OpenSOAP {

  //DOM
  class XmlQuery {
  public:
    XmlQuery(const std::string& query);
    ~XmlQuery();
    
    //l̎擾
    //擾łtrueԂ
    //RootQuery  RootNoden
    //int getValue(xmlDocPtr& doc, xmlNodePtr node);
    int getValue(xmlDocPtr& doc, xmlNodePtr node, 
		 std::vector<std::string>& values);

    //l̊i[ꏊ
    //ꍇL
    std::vector<std::string> value;

	bool isMulti() const;

    void spy() const;

  protected:

    class DataSet {
    public:
      DataSet() : value(NULL) {}
      DataSet(const DataSet& ds) : value(NULL) {
	setName(ds.name);
	if (ds.value) { setValue(*(ds.value)); }
      } 

      ~DataSet() { if (value) { delete value; } }

      // get method
      const std::string& getName() const { return name; }
      //const std::string* getValue() const { return value; }
      const std::string getValue() const { return isNullValue() ? "" : *value; }

      // set method
      void setName(const std::string& aName) { name = aName; }
      //l̐ݒ(lƂ)
      //ŏIIȎ擾ړIlXmlQuery::value̗vfƂ
      //  ݒ肳
      void setValue(const std::string& aValue) { 
	if (!value) { 
	  value = new std::string(aValue); 
	}
	else {
	  *value = aValue;
	}
      }
      //l̏
      void clearValue() {
	if (value) {
	  delete value;
	  value = NULL;
	}
      }
      //lNULLǂB
      //NULLłȂΏlBNULLȂ擾ړIlƂďB
      bool isNullValue() const { return NULL == value ? true : false; }

      void spy() const {
	cerr << " name=[" << name << "]" << endl;
	cerr << " value=[" 
	     << (NULL == value ? "<null>" : *value) << "]" << endl;
      }

    protected:
      std::string name;
      std::string* value; //NULLłȂΏlBNULLȂ擾ړIl
    };

    //qCX^X|C^
    XmlQuery* next_;

    //std::string nodeName_; //(K{)
    DataSet node_;

    //̃m[h̗vflړIǂB
    //vf͕K{ł邽߁AvfL肩lݒ(NULL)Ƃ
    //ł͖ړIlǂfłȂ߁B
    bool isTarget_; 

    //̒lvĂ邩ǂB(??A?͂P̂)
    //ĂȂꍇ͏߂ɌʂԂB
    bool isMulti_;

    //
    std::vector<DataSet> attributes_;

    void addName(const std::string& nameToken);
    void addAttributes(const std::string& attrToken);

  };

} // end of namespace OpenSOAP


#endif _XMLQuery_H_
